package it.unibo.cs.labp.progetto2001.solmi;

import java.io.*;
import it.unibo.cs.labp.progetto2001.spec.*;

/**
 * @author Riccardo Solmi
 */

public class IfStatement implements Statement {
	private Expression exp;

	private Statement thenStm;

	private Statement elseStm;

	public IfStatement(Expression exp, Statement thenStm) {
		this.exp = exp;
		this.thenStm = thenStm;
		this.elseStm = null;
	}

	public IfStatement(Expression exp, Statement thenStm, Statement elseStm) {
		this.exp = exp;
		this.thenStm = thenStm;
		this.elseStm = elseStm;
	}

	public void prettyPrint(PrintStream out) {
		out.print("if (");
		exp.prettyPrint(out);
		out.println(") {");
		thenStm.prettyPrint(out);
		if (elseStm == null)
			out.println("}");
		else {
			out.println("} else {");
			elseStm.prettyPrint(out);
			out.println("}");
		}
	}

	public void execute() {
		if (exp.evaluate().booleanValue())
			thenStm.execute();
		else if (elseStm != null)
			elseStm.execute();
	}
}