package it.unibo.cs.labp.progetto2001.solmi;

import java.io.*;
import it.unibo.cs.labp.progetto2001.spec.*;

/**
 * @author Riccardo Solmi
 */

public class LessThanExpression implements Expression {
	private Expression exp1;

	private Expression exp2;

	public LessThanExpression(Expression exp1, Expression exp2) {
		this.exp1 = exp1;
		this.exp2 = exp2;
	}

	public void prettyPrint(PrintStream out) {
		exp1.prettyPrint(out);
		out.print(" < ");
		exp2.prettyPrint(out);
	}

	public Literal evaluate() {
		return new BooleanLiteral(exp1.evaluate().intValue() < exp2.evaluate().intValue());
	}
}