package it.unibo.cs.labp.progetto2001.solmi;

import java.io.*;
import it.unibo.cs.labp.progetto2001.spec.*;

/**
 * @author Riccardo Solmi
 */

public class Variable implements Expression {
	private String id;

	private Literal val;

	public Variable(String id) {
		this.id = id;
	}

	public void prettyPrint(PrintStream out) {
		out.print(id);
	}

	public void setValue(Literal val) {
		this.val = val;
	}

	public Literal evaluate() {
		if (val == null)
			throw new IllegalStateException("Variabile non inizializzata");

		return val;
	}

	public String toString() {
		if (val == null)
			throw new IllegalStateException("Variabile non inizializzata");
		return val.toString();
	}
}