package it.unibo.cs.labp.progetto2001.solmi;

import java.io.*;
import it.unibo.cs.labp.progetto2001.spec.*;

/**
 * @author Riccardo Solmi
 */

public class WhileStatement implements Statement {
	private Expression exp;

	private Statement stm;

	public WhileStatement(Expression exp, Statement stm) {
		this.exp = exp;
		this.stm = stm;
	}

	public void prettyPrint(PrintStream out) {
		out.print("while (");
		exp.prettyPrint(out);
		out.println(") {");
		stm.prettyPrint(out);
		out.println("}");
	}

	public void execute() {
		while (exp.evaluate().booleanValue())
			stm.execute();
	}
}